!******************************
      module globande

	integer, parameter:: NBAN=11,NSPL=30
      real, dimension(nspl):: X, Y  
	real, dimension(nspl,nban):: WL,TRA
	CHARACTER(len=2),dimension(nban):: 
     @BAN=(/'UX','BX','B ','V ','R ','I ','J ','H ','K ','L ','M '/)
	REAL::ZP(NBAN),TRATOT(NBAN),FLUMED(NBAN),MAG(NBAN),CI(NBAN,NBAN)
	REAL::Lbanda(NBAN)
	integer,save:: ibancur

      !variabili che servono solo per settare i punti zero.
	real,dimension(nban)::mag_veg
	!sono le mags di vega assunte dagli autori da cui ho preso
      !i flussi a mag 0 - f_0 def sotto e prese dalla tesi di Gian - 
      !se hanno usato lo stesso spettro di Vega che uso io. 
      real,dimension(nban)::lam_eff=
     @ (/.330e4,.445e4,.445e4,.546e4,.640e4,.798e4,
     @   1.26e4,1.6e4,2.22e4,3.54e4, 4.8e4 /)  !A
      real,dimension(nban)::f_0=
     @ (/3.697e-9,6.635e-9,6.635e-9,3.673e-9,2.256e-9,1.158e-9,
     @   3.029e-10,1.260e-10,4.134e-11,6.894e-12,2.213e-12 /) !erg/cm^2/s/A 

      real,dimension(nban)::flu_lam_eff

	end module globande
!******************************
      module gloinpspe

	REAL,dimension(:), allocatable:: WLPP,IWLPP
	integer:: npp


	!!!per dare in output anche flussi ossevati in mjy a certe lambda
	REAL,dimension(:), allocatable:: WL2,IWL2
	integer,parameter::n_lam=5
	REAL,dimension(n_lam)::lam_arr=(/75.,110.,170.,450.,850./)  !in micron
	REAL,dimension(n_lam):: Lnu_arr

	end module gloinpspe
!******************************
      module glo_flu_old

 	!PARAMETRI DEGLI SPETTRI COMPONENTI
	REAL:: TBB,ALPHA
 	!PESI DELLE VARIE COMPONENTI SPETTRALI ALLA LUNGHEZZA D'ONDA WLCF
	real:: wlcf,cbb,cpl,cpp

	end module glo_flu_old
!***********************************************************
      module functions_mag

	contains

	FUNCTION SISFOT(WL)
!	TRASMISSIONE DEL SISTEMA FOTOMETRICO interpolato
!     ALLA LUNGHEZZA D'ONDA WL in A PER IL FILTRO INIZIALIZZATO CON INISPL

      use nr90_gian
      use globande, only: X,Y, nspl

      implicit none

	real,dimension(:),intent(in)::wl
	real,dimension(size(wl))::sisfot
	integer::io,j, ii
	real:: dy

      do j=1,size(wl)
  	    IF ((WL(j) <= X(1)).OR.(WL(j) >= X(NSPL))) THEN
		     SISFOT(j)=0
	    ELSE
!qui pare che interpolare con un polinomio di 3^o grado
!dia risultati migliori rispetto all' interpolazione lineare
!nel senso che i colori di vega sono molto piu' vicini a zero
               call liin(x,y,wl(j),sisfot(j),io)  !io e' opzionale
!	         call POINH(X,Y,nspl,4,wl,sisfot,DY,II)
	         if (sisfot(j)<0.) write(*,*) wl(j), sisfot(j)
	    ENDIF
      enddo

	END FUNCTION SISFOT

*-----------------------------------------------------------------------
	real FUNCTION PP(lam)

!	interpola lo spettro letto nel file name alla lambda wl in A

      use nr90_gian
      use gloinpspe 
      implicit none

      integer:: io, npol, ii,j
	real:: dy
      real, intent(in)::lam
  	!real,dimension(:),intent(in):: wl
	!real,dimension(size(wl))::PP

	if (npp <=1 ) THEN
	   pp=0
      else
            call liin(wlpp,iwlpp,lam,pp,io)  !io e' opzionale
!	      call POINH(wlpp,iwlpp,npp,4,wl,pp,DY,II)
	endif

	END FUNCTION PP

*-----------------------------------------------------------------------
	FUNCTION FLU(WL)
!	SPETTRO ALLA LUNGHEZZA D'ONDA WL IN Ang PER LA TRASMISSIONE 
!     DEL SISTEMA FOTOMETRICO

	implicit none
	real,dimension(:), intent(in)::wl
	real,dimension(size(wl))::flu,pptmp,sisfottmp
      !real::pp,sisfot
	integer::j
	! la function PP interpola con liin nello spettro di input,
	! la function SISFOT interpola con la poinh nelle risposte
	! delle varie bande
	do j=1,size(wl)
	   pptmp(j)=PP(WL(j))
      enddo
         sisfottmp=sisfot(wl)
	   FLU=PPtmp*sisfottmp   ! SISFOT(WL)

	END FUNCTION FLU


	FUNCTION FLUnorm(WL)
!	SPETTRO ALLA LUNGHEZZA D'ONDA WL IN Ang PER LA TRASMISSIONE 
!     DEL SISTEMA FOTOMETRICO, normalizzata a 1
      use globande, only: X,Y, nspl,ibancur,tratot

	implicit none
	real,dimension(:), intent(in)::wl
	real,dimension(size(wl))::flunorm,pptmp,sisfottmp
      !real::pp,sisfot
	integer::j
	! la function PP interpola con liin nello spettro di input,
	! la function SISFOT interpola con la poinh nelle risposte
	! delle varie bande
	do j=1,size(wl)
	   pptmp(j)=PP(WL(j))
      enddo
         sisfottmp=sisfot(wl)/tratot(ibancur)  !qromb_eps(SISFOT,X(1),X(NSPL),eps)
	   FLUnorm=PPtmp*sisfottmp   ! SISFOT(WL)

	END FUNCTION FLUnorm


	end module functions_mag
!************************************************************

      SUBROUTINE C_I

      use nr90_gian
      use modname
      use parametri,only:nopt,redshift
      use globande
	use gloinpspe
	use functions_mag

	implicit none

      character(len=80)::fileout, formout
      integer::i,j,iban,jban,io
	!real::pp
	real, parameter:: EPS=1E-5
      real::yout

	!real flu,sisfot   !,flu_old
	!EXTERNAL SISFOT,FLU   !,FLU_OLD
	
!************
      !input lambda e trasmissione delle bande
	CALL INPBAN   
      !input spettro di cui calcolare i colori
	CALL INPSPE   

	!qui ho letto ed aventualmente redshiftato le SED. Ho npp lamda (WLPP) in Ang 
	!e L_lam (IWLPP) in erg/cm^2/s/A
	!!!Trovo i flussi osservati in mjy alle lambda definite in lam_arr in gloinpspe
	!do i=1,n_lam
	!	
	!	!call liin(WLPP,IWLPP,lam_arr(i)*1e4,yout,io)
	!	!Lnu_arr(i)=log10(yout)+2.*log10(lam_arr(i))-log10(3.)+16.  !yout*lam_arr(i)/3.*lam_arr(i)*1e16  !in mjy		
	!	call liin(wl2,iwl2,3e14/lam_arr(i)*(1+redshift),yout,io)
	!	Lnu_arr(i)=log10(yout)+26.

	!enddo


!     FLUSSI MEDIATI IN LAMBDA
	DO IBAN=1,NBAN
		CALL INISPL(IBAN)
		ibancur=iban
		!CALL qromb(SISFOT,X(1),X(NSPL),TRATOT(IBAN),EPS)
		tratot(iban)=qromb_eps(SISFOT,X(1),X(NSPL),eps)
          flu_lam_eff=flu(lam_eff)      
      	write(*,*) flu_lam_eff 
		if ( flu_lam_eff(iban) >0 ) then  !if ( flu(lam_eff(iban)) >0 ) then 
              !CALL qromb(FLU,X(1),X(NSPL),FLUMED(IBAN),EPS)
		    flumed(iban)=qromb_eps(FLU,X(1),X(NSPL),eps)
	        Lbanda(iban)=flumed(iban)/(8.3577e-11)  !in 1e30 erg/s/A  !qromb_eps(FLUnorm,X(1),X(NSPL),eps)/(8.3577e-11) 
			FLUMED(IBAN)=FLUMED(IBAN)/TRATOT(IBAN)
		write(*,*)"IBAN,TRATOT= ", iban, tratot(iban)
          else
              flumed(iban)=0
	    endif

      ENDDO

!			   /
!			   | L(lam)*T(lam) dlam
!			  /
!flumed(iban)= -----------------------   (1e30 erg/s)
!			   /
!			   | T(lam) dlam
!			  /


!******************
!la prima condizione e' quella che viene usata per calcolare 
!mag e  colori, la seconda per fissare i punti zero dati quelli 
!letti in bande.dat (poi da sostituire) e lo spettro di vega

      if (.true.) then

          mag=-2.5*log10(flumed/zp+10*tiny(1.0))  !i punti 0 sono dati come flussi
	    ! a mag 0. occhio alle unita' 

		DO IBAN=1,NBAN-1
			DO JBAN=IBAN+1,NBAN
				CI(IBAN,JBAN)=mag(iban)-mag(jban)
  		    enddo
	    enddo

          call outcoltab  !output mags e colori a tabella

	    if (nopt > 0) then
             call outcolevol  !output alcuni colori in colonna per plots
	    endif

      else

          ! mag_veg(lam_eff)=-2.5*log(f_lam_eff vega/f_lam_eff(o))
          ! flumed(banda)=-2.5*log<f_lam vega>_banda
          ! zp=-flumed+mag oppure =10**(0.4*(-flumed+mag))

          flumed=-2.5*log10(flumed)
          do i=1,nban
	        mag_veg(i)=-2.5*log10(pp(lam_eff(i))/f_0(i))
          enddo
          zp=-flumed+mag_veg
     		fileout='zp'//name
		OPEN(100,FILE=fileout)
          write(100,'(2x,20a13)')    (ban(i),i=1,nban)
	    write(100,'(2x,20f13.5)') (lam_eff(i)/1e4,i=1,nban)
		write(100,*) 'zero points in mag' 
          write(100,'(2x,20f13.5)') (zp(i),i=1,nban) 
          zp=10**(0.4*zp)
	    write(100,*) 'zero points in flux erg/cm^2/s/A'
          write(100,13) (zp(i),i=1,nban)
	    zp=lam_eff*zp*lam_eff*3.333e4
	    write(100,*) 'zero points in flux jy'
          write(100,13) (zp(i),i=1,nban)
	    write(100,*) 'orig zero points in flux erg/cm^2/s/A'
          write(100,13) (f_0(i),i=1,nban) 
	    write(100,*) 'orig zero points in flux jy'
          write(100,13) 
     @	(f_0(i)*lam_eff(i)*lam_eff(i)*3.333e4,i=1,nban) 
            
	    close(100)
 
 13   format(2x,20(1pe13.3))
	endif

	END SUBROUTINE C_I

 